Merge branch 'master' of git://git.kernel.org/pub/scm/fs/xfs/xfstests-dev
[xfstests-dev.git] / 030
1 #! /bin/bash
2 # FS QA Test No. 030
3 #
4 # exercise xfs_repair repairing broken filesystems
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=nathans@sgi.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=1        # failure is the default!
33
34 _cleanup()
35 {
36         cd /
37         umount $SCRATCH_DEV 2>/dev/null
38         rm -f $tmp.*
39 }
40
41 trap "_cleanup; exit \$status" 0 1 2 3 15
42
43 # get standard environment, filters and checks
44 . ./common.rc
45 . ./common.filter
46 . ./common.repair
47
48 # link correct .out file
49 _link_out_file $seq.out
50
51 # nuke the superblock, AGI, AGF, AGFL; then try repair the damage
52 #
53 _check_ag()
54 {
55         for structure in 'sb 0' 'agf 0' 'agi 0' 'agfl 0'
56         do
57                 echo "Corrupting $structure - setting bits to $1"
58                 _check_repair $1 "$structure" |
59                         sed -e '/^error following ag 0 unlinked list$/d'
60         done
61 }
62
63 # real QA test starts here
64 _supported_fs xfs
65 _supported_os IRIX Linux
66
67 _require_nobigloopfs
68 _require_scratch
69
70 DSIZE="-dsize=100m,agcount=6"
71
72 # first we need to ensure there are no bogus secondary
73 # superblocks between the primary and first secondary
74 # superblock (hanging around from earlier tests)...
75 #
76
77 _scratch_mkfs_xfs $DSIZE >/dev/null 2>&1
78 if [ $? -ne 0 ]         # probably don't have a big enough scratch
79 then
80         _notrun "SCRATCH_DEV too small, results would be non-deterministic"
81 else
82         _scratch_mount
83         src/feature -U $SCRATCH_DEV && \
84                 _notrun "UQuota are enabled, test needs controlled sb recovery"
85         src/feature -G $SCRATCH_DEV && \
86                 _notrun "GQuota are enabled, test needs controlled sb recovery"
87         src/feature -P $SCRATCH_DEV && \
88                 _notrun "PQuota are enabled, test needs controlled sb recovery"
89         umount $SCRATCH_DEV
90 fi
91 clear=""
92 eval `xfs_db -r -c "sb 1" -c stack $SCRATCH_DEV | perl -ne '
93         if (/byte offset (\d+), length (\d+)/) {
94                 print "clear=", $1 / 512, "\n"; exit
95         }'`
96 [ -z "$clear" ] && echo "Cannot calculate length to clear"
97 src/devzero -v -1 -n "$clear" $SCRATCH_DEV >/dev/null
98
99 # now kick off the real repair test...
100 #
101 _scratch_mkfs_xfs $DSIZE | _filter_mkfs 2>$tmp.mkfs
102 . $tmp.mkfs
103 _check_ag 0
104 _check_ag -1
105
106
107 # success, all done
108 status=0
109 exit